package com.bn.qa.blade;

import jssc.SerialPort;
import jssc.SerialPortException;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream; 
import java.util.ArrayList;
import java.util.Date;

public class Main {
	InputStream inputStream;
	static SerialPort serialPort;

    public static void main(String[] args) throws Exception {
    	
    	boolean rename = false;
    	Date fileNameDate = new Date();
    	String fullLogFileName = "full_log_"+fileNameDate.toString().replace(":", "-").replace(" ", "_"); 
    	
    	System.out.println(fullLogFileName);
    	
    	File fullLogFile = new File("logs/"+fullLogFileName);
    	if(!fullLogFile.exists()){
    		fullLogFile.createNewFile();
    	}
    	
    	String fileNameWorkingWith = FileCommandsName.getFilesList().get(0).toString();
    	System.out.println(fileNameWorkingWith);
	    	
	    for(int totalCounter=0; totalCounter<GetCommandsListToExecute.loopsAmount(fileNameWorkingWith); totalCounter++){
	    	
        	SaveFullLogs.savingLogs(fullLogFileName, "\n");
	    	
	    	SaveFullLogs.savingLogs(fullLogFileName, "Loop number: " + (totalCounter+1));
	    	
	        serialPort = new SerialPort(GetCommandsListToExecute.portNameExtractor(fileNameWorkingWith));
	        
	        ArrayList commandsToExecute = GetCommandsListToExecute.commandExtractor(fileNameWorkingWith);
	        
	        for(int counter=0; counter<commandsToExecute.size(); counter++){
	        	
	            Date date = new Date();
	            System.out.println(date.toString());
	            SaveFullLogs.savingLogs(fullLogFileName, date.toString());
	            
	            String commandToRun = commandsToExecute.get(counter).toString().substring(0, commandsToExecute.get(counter).toString().indexOf(",")).replace("command:", "").trim();
	            String[] splitCommandString = commandsToExecute.get(counter).toString().split(",");
	            String timeToWaitBeforeStep = splitCommandString[1].trim();
	            int singleCommandRepetition = Integer.parseInt(splitCommandString[2].trim());
	            
	            for(int singleCmdCounter=0; singleCmdCounter<singleCommandRepetition; singleCmdCounter++){
		            System.out.println("Executing command: " + commandToRun + " - " + (singleCmdCounter+1) + " time.");
		            System.out.println("Waiting before command execution: "+ timeToWaitBeforeStep);
		            SaveFullLogs.savingLogs(fullLogFileName, "Waiting before command execution: "+ timeToWaitBeforeStep);
		            SaveFullLogs.savingLogs(fullLogFileName, "Executing command: " + commandToRun + " - " + (singleCmdCounter+1) + " time.");
	            
			        try {
			            serialPort.openPort();//Open serial port
			            //serialPort.setParams(SerialPort.BAUDRATE_115200,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
			            serialPort.setParams(GetSerialPortParams.baudrateExtractor(fileNameWorkingWith),GetSerialPortParams.databitsExtractor(fileNameWorkingWith),GetSerialPortParams.stopbitsExtractor(fileNameWorkingWith),GetSerialPortParams.parityExtractor(fileNameWorkingWith));
			            Thread.sleep(Integer.parseInt(timeToWaitBeforeStep));
			            serialPort.writeString(commandToRun + "\r");//Write data to port
			            Thread.sleep(1000);
			            byte[] buffer = serialPort.readBytes();
			            String s = new String(buffer);
			            System.out.println("Bytes decryted into String: "+ s);
			            SaveFullLogs.savingLogs(fullLogFileName, s.toString());
			            if (s.toString().toLowerCase().contains("exception") || s.toString().toLowerCase().contains("error")){
			            	rename=true;
			            }
			
			            serialPort.closePort();//Close serial port
			           
			        } catch (Exception ex) {
			            System.out.println(ex);
			            SaveFullLogs.savingLogs(fullLogFileName, ex.toString());
			            serialPort.closePort();
			        }    
	            }
	        }
    	}
        
	    if (rename){
	    	File fullLogFileNameError = new File("logs/"+fullLogFileName+"_ERROR");
	    	fullLogFile.renameTo(fullLogFileNameError);
	    }
    }
   
}